/*
 * The Clear BSD License
 * Copyright 2018 L-Tek
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted (subject to the limitations in the disclaimer below) provided
 * that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of the copyright holder nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PIN_MUX_H_
#define _PIN_MUX_H_

/*!
 * @addtogroup pin_mux
 * @{
 */

/***********************************************************************************************************************
 * API
 **********************************************************************************************************************/

#if defined(__cplusplus)
extern "C" {
#endif

/*!
 * @brief Calls initialization functions.
 *
 */
void BOARD_InitBootPins(void);

/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO029_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 1. */
#define PIO029_FUNC_ALT1 0x01u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO030_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 1. */
#define PIO030_FUNC_ALT1 0x01u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO126_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 0. */
#define PIO126_FUNC_ALT0 0x00u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Pull-down.
 * Pull-down resistor enabled.
 */
#define PIO126_MODE_PULL_DOWN 0x01u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO127_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 0. */
#define PIO127_FUNC_ALT0 0x00u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Pull-down.
 * Pull-down resistor enabled.
 */
#define PIO127_MODE_PULL_DOWN 0x01u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO128_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 0. */
#define PIO128_FUNC_ALT0 0x00u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Pull-down.
 * Pull-down resistor enabled.
 */
#define PIO128_MODE_PULL_DOWN 0x01u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO13_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 0. */
#define PIO13_FUNC_ALT0 0x00u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Pull-down.
 * Pull-down resistor enabled.
 */
#define PIO13_MODE_PULL_DOWN 0x01u

/*! @name PIO1_3 (number 120), LED1
  @{ */
#define BOARD_INITPINS_LED1_GPIO GPIO /*!<@brief GPIO device name: GPIO */
#define BOARD_INITPINS_LED1_PORT 1U   /*!<@brief PORT device name: 1U */
#define BOARD_INITPINS_LED1_PIN 3U    /*!<@brief 1U pin index: 3 */
                                      /* @} */

/*! @name PIO1_27 (number 142), LED2
  @{ */
#define BOARD_INITPINS_LED2_GPIO GPIO /*!<@brief GPIO device name: GPIO */
#define BOARD_INITPINS_LED2_PORT 1U   /*!<@brief PORT device name: 1U */
#define BOARD_INITPINS_LED2_PIN 27U   /*!<@brief 1U pin index: 27 */
                                      /* @} */

/*! @name PIO1_26 (number 131), LED3
  @{ */
#define BOARD_INITPINS_LED3_GPIO GPIO /*!<@brief GPIO device name: GPIO */
#define BOARD_INITPINS_LED3_PORT 1U   /*!<@brief PORT device name: 1U */
#define BOARD_INITPINS_LED3_PIN 26U   /*!<@brief 1U pin index: 26 */
                                      /* @} */

/*! @name PIO1_28 (number 151), LED4
  @{ */
#define BOARD_INITPINS_LED4_GPIO GPIO /*!<@brief GPIO device name: GPIO */
#define BOARD_INITPINS_LED4_PORT 1U   /*!<@brief PORT device name: 1U */
#define BOARD_INITPINS_LED4_PIN 28U   /*!<@brief 1U pin index: 28 */
                                      /* @} */

/*! @name FC0_TXD_SCL_MISO (number 200), USBTX
  @{ */
/* @} */

/*! @name FC0_RXD_SDA_MOSI (number 167), USBRX
  @{ */
/* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitPins(void); /* Function assigned for the Cortex-M4F */

#if defined(__cplusplus)
}
#endif

/*!
 * @}
 */
#endif /* _PIN_MUX_H_ */

/***********************************************************************************************************************
 * EOF
 **********************************************************************************************************************/
